from qmdl.helper import Helper
from collections import defaultdict
#read the model file
self = Helper()
self.load("glaunch.mdl")


current_merge_lists  = {"only":range(len(self.mdl.vertices))}
for frame in self.mdl.frames:
    prior_merge_lists = current_merge_lists
    current_merge_lists = defaultdict(list)
    i = 0
    for merge_list in prior_merge_lists.values():
        for v_index in merge_list:
            coord = frame.vertices[v_index] 
            key = (coord.position, i)
            current_merge_lists[key].append(v_index)
        i = i + 1

for frame in self.mdl.frames:
    for v_list in current_merge_lists.values():
        norm = [0, 0, 0]
        for vert in v_list:
            norm = map(sum, zip(frame.vertices[vert].decode(), norm))
        norm = tuple(norm)
        for vert in v_list:
            frame.vertices[vert].encode(norm)

self.save()
        
